----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 02/19/2020 10:10:52 PM
-- Design Name: 
-- Module Name: ADDER_n - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity ADDER_n is
    generic (WIDTH : positive := 4); -- set 4 as default value
    port (
        A    :  in STD_LOGIC_VECTOR (WIDTH-1 downto 0);
        B    :  in STD_LOGIC_VECTOR (WIDTH-1 downto 0);
        S    : out STD_LOGIC_VECTOR (WIDTH-1 downto 0);
        Cout : out STD_LOGIC;
        OV   : out STD_LOGIC);
end ADDER_n;

architecture Behavioral of ADDER_n is
begin
  ADDER: process (A, B) 
  variable A_s, B_s, S_s: SIGNED (WIDTH+1 downto 0);
  begin
    A_s := signed('0'&A(WIDTH-1)&A);              -- numeric_std
    B_s := signed('0'&B(WIDTH-1)&B);              -- numeric_std
    S_s := A_s + B_s;                             -- numeric_std
    S <= std_logic_vector(S_s(WIDTH-1 downto 0)); -- numeric_std
    OV <= S_s(WIDTH) xor S_s(WIDTH-1);
    Cout <= S_s(WIDTH+1);                 
  end process;
end Behavioral;
